--https://love2d.org/wiki/Tutorial:Callback_Functions
	enemy = {}
	enemies_controller = {}
	enemies_controller.enemies = {}
	enemies_controller.image = love.graphics.newImage('gfx/enemy.png')

timer = 0
function newWave()
	for i=0, 10 do
		enemies_controller:spawnEnemy(i * 70,0)
	end
end

	function checkCollisions(enemies, bullets) --enemies and bullets colliding?
		for _,e in ipairs(enemies) do
			for _,b in pairs(bullets) do
				if b.y <= e.y + e.height and b.x > e.x and b.x < e.x + e.width then
					table.remove(enemies, i)
				end
			end
		end
	end

function love.load() --called once!!!
	background_image = love.graphics.newImage('gfx/background.png')
	player = {}
	player.x = 0
	player.y = 550
	player.bullets = {}
	player.cooldown = 20
	player.image = love.graphics.newImage('gfx/player.png')
	player.fire_sound = love.audio.newSource('laser2.wav')
	player.fire = function() --fires bullet
		if player.cooldown <= 0 then
			love.audio.play(player.fire_sound)
			player.cooldown = 20
			bullet = {}
			bullet.x = player.x + 71
			bullet.y = player.y
			table.insert(player.bullets, bullet)
		end
	end

--function newWave()
	for i=0, 10 do
		enemies_controller:spawnEnemy(i * 70,0)
	end
--end


	love.graphics.setDefaultFilter('nearest', 'nearest')
end

function enemies_controller:spawnEnemy(x,y)
	enemy = {}
	enemy.x = x
	enemy.y = y
	enemy.width = 64
	enemy.height = 75
	enemy.bullets = {}
	enemy.cooldown = 20
	enemy.speed = 10 -- is this need? iDunno, the newest Apple gadget!
	table.insert(self.enemies, enemy)
end

function enemy:fire()
	if self.cooldown <= 20 then
	self.cooldown = 20
	bullet = {}
	bullet.x = self.x + 35
	bullet.y = self.y
	table.insert(self.bullets, bullet)
	end
end


function love.update(dt) --delta time!
	player.cooldown = player.cooldown - 1
	if love.keyboard.isDown("right") then
		player.x = player.x + 3
	elseif love.keyboard.isDown("left")	then
		player.x = player.x - 3
	end
	--[[ this is basically changing y.
	if love.keyboard.isDown("up") then
		y = y-1
	elseif love.keyboard.isDown("down")	then
		y = y+1
	end
	--]]

	if love.keyboard.isDown(" ") then --fire!!!
		player.fire()
	end

	for _,e in pairs(enemies_controller.enemies) do --enemy moves down
			e.y = e.y + 0.5
	end


	for i,b in ipairs(player.bullets) do --bullets remover
		if b.y < -10 then
			table.remove(player.bullets, i)
		end
		b.y = b.y - 10
	end

timer = timer + love.timer.getDelta()
	        if math.floor(timer) > 5 then
	                newWave()
	                timer = 0
	        end

	checkCollisions(enemies_controller.enemies, player.bullets)
end

function love.draw() --every tick! (60 times per second)
	love.graphics.draw(background_image, 0, 0, 0, 4)

	love.graphics.setColor(255,255,255)--begin player draw --protip: .setColor sets for all the following graphics scripts, until another .setColor comes along. Like Scratch's set color blocks! Isn't programming great?
	love.graphics.draw(player.image, player.x, 550, 0, 1) --end player draw

	love.graphics.setColor(255,255,2555) --begin Enemy Draw
	for _,e in pairs(enemies_controller.enemies) do
		love.graphics.draw(enemies_controller.image, e.x, e.y, 0, 1)
	end --end Enemy Draw

	love.graphics.setColor(255,255,255) --draw the bullet
	for _,b in pairs(player.bullets) do
		love.graphics.rectangle("fill", b.x, b.y, 10, 10) --draws bullet
	end
end
